package it.unina.at;

import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;
import javax.xml.parsers.*;

import org.xml.sax.XMLReader;
import org.xml.sax.SAXException;
import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;

public class Servlet02 extends HttpServlet {

	private String xml_file = "http://localhost:8080/AT_servlets/test.xml";

	public void doPost(HttpServletRequest request, HttpServletResponse response) 
	throws ServletException, java.io.IOException 
	{
		String param = (String)request.getParameter("file");

		if (param != null)
			xml_file = param;
		
		PrintWriter out = response.getWriter(); 
		out.println("<html><h2>Questa servlet usa un parser SAX per scandire il file "+ xml_file + "</h2></html>"); 
		try {
			SAXParserFactory spf = SAXParserFactory.newInstance();
			SAXParser saxp = spf.newSAXParser();
			XMLReader parser = saxp.getXMLReader();
			parser.setContentHandler(new SimpleHandler(out));
			out.println("Parsing di " + xml_file + " con " + parser.getClass().getName() + "<br>"); 
//			out.println("<UL>");
			parser.parse(xml_file);
//			out.println("</UL>");
		}
		catch (SAXException e) {
			e.printStackTrace();
			e.getException().printStackTrace();
		} 
		catch (ParserConfigurationException e) {
			e.printStackTrace();
		}
		out.println("<br>Fine."); 
	}

	public void doGet(HttpServletRequest request, HttpServletResponse response) 
	throws ServletException, java.io.IOException 
	{
		doPost(request, response);
	}
}

class SimpleHandler extends DefaultHandler 
{
	private PrintWriter w;
	
	public SimpleHandler(PrintWriter w)
	{
		this.w = w;
	}
	
	public void startElement(String uri,
							 String localName,
							 String qName,
							 Attributes attributes) throws SAXException 
	{
		w.println ("<UL><LI>" + qName);            
	}
	
	public void endElement(String uri,
							 String localName,
							 String qName) throws SAXException 
	{
		w.println ("</LI></UL>");            
	}
}
